src/main/java/maxempresarial/controlador/cadastro/PaisBean.java
package maxempresarial.controlador.cadastro;

import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.Serializable;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.view.ViewScoped;
import javax.imageio.ImageIO;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.FillPatternType;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.IndexedColors;
import org.primefaces.context.RequestContext;
import org.primefaces.model.LazyDataModel;
import org.primefaces.model.SortOrder;
import org.primefaces.model.UploadedFile;

import maxempresarial.modelo.Pais;
import maxempresarial.repositorio.dao.ExcecaoDAO;
import maxempresarial.repositorio.filtro.PaisFiltro;
import maxempresarial.repositorio.pesquisa.PaisPesquisa;
import maxempresarial.servico.ExcecaoRN;
import maxempresarial.servico.PaisServico;
import maxempresarial.util.jsf.FacesUtil;

@Named
@ViewScoped
public class PaisBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private PaisServico paisServico;

	@Inject
	private PaisPesquisa paisPesquisa;

	private Pais pais;
	private UploadedFile uploadArquivo = null;
	private PaisFiltro filtro;
	private LazyDataModel<Pais> lazyPaises;

	@PostConstruct
	public void inicializar() {
		this.filtro = new PaisFiltro();

		this.lazyPaises = new LazyDataModel<Pais>() {

			private static final long serialVersionUID = 1L;

			@Override
			public List<Pais> load(int primeiroRegistro, int quantidadeRegistros, String propriedadeOrdenacao, SortOrder ascendente,
					Map<String, Object> filters) {

				filtro.setPrimeiroRegistro(primeiroRegistro);
				filtro.setQuantidadeDeRegistros(quantidadeRegistros);
				filtro.setPropriedadeParaOrdenacao(propriedadeOrdenacao);
				filtro.setAscendente(SortOrder.ASCENDING.equals(ascendente));

				this.setRowCount(paisPesquisa.quantidadePaisesFiltrados(filtro));

				return paisPesquisa.filtrados(filtro);
			}

		};
	}

	public void adicionar() {
		this.pais = new Pais();
	}

	public void salvarPais() {
		RequestContext context = RequestContext.getCurrentInstance();
		boolean adicionado = false;

		try {
			if (this.uploadArquivo != null) {
				this.pais.setBandeira(this.uploadArquivo.getContents());
			}
			this.pais = this.paisServico.salvar(this.pais);
			adicionado = true;
			this.pais = new Pais();

			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("salvo_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("salvo_corretamente_detalhes"));
		} catch (ExcecaoRN ern) {
			FacesUtil.mensagemAviso(FacesUtil.getMensagemInternacionalizacao("atencao_mensagem"), FacesUtil.getMensagemInternacionalizacao(ern.getMessage()));
		} catch (ExcecaoDAO edao) {
			FacesUtil.mensagemErro(FacesUtil.getMensagemInternacionalizacao("salvo_falha_mensagem"), edao.getMessage());
		}
		context.addCallbackParam("adicionado", adicionado);
	}

	public void posProcessarXls(Object documento) {
		HSSFWorkbook planilha = (HSSFWorkbook) documento;
		HSSFSheet folha = planilha.getSheetAt(0);
		HSSFRow cabecalho = folha.getRow(0);
		HSSFCellStyle estiloDaCelula = planilha.createCellStyle();
		Font fonteDoCabecalho = planilha.createFont();

		fonteDoCabecalho.setColor(IndexedColors.WHITE.getIndex());
		fonteDoCabecalho.setBold(true);
		fonteDoCabecalho.setFontHeightInPoints((short) 13);

		estiloDaCelula.setFont(fonteDoCabecalho);
		estiloDaCelula.setFillForegroundColor(IndexedColors.BLACK.getIndex());
		estiloDaCelula.setFillPattern(FillPatternType.SOLID_FOREGROUND);

		for (int i = 0; i < cabecalho.getPhysicalNumberOfCells(); i++) {
			cabecalho.getCell(i).setCellStyle(estiloDaCelula);
		}

	}

	public void excluir() {
		try {
			this.paisServico.excluir(this.pais);

			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("exclusao_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("exclusao_corretamente_detalhes"));
		} catch (ExcecaoRN ern) {
			FacesUtil.mensagemAviso(FacesUtil.getMensagemInternacionalizacao("atencao_mensagem"), FacesUtil.getMensagemInternacionalizacao(ern.getMessage()));
		} catch (ExcecaoDAO edao) {
			FacesUtil.mensagemErro(FacesUtil.getMensagemInternacionalizacao("exclusao_falha_mensagem"), edao.getMessage());
		}
	}

	public Pais getPais() {
		return this.pais == null ? null : this.pais;
	}

	public void setPais(Pais pais) {
		this.pais = pais;
	}

	public PaisFiltro getFiltro() {
		return filtro;
	}

	public LazyDataModel<Pais> getLazyPaises() {
		return lazyPaises;
	}

	public UploadedFile getUploadArquivo() {
		return uploadArquivo;
	}

	public void setUploadArquivo(UploadedFile uploadArquivo) {
		this.uploadArquivo = uploadArquivo;
	}

	public BufferedImage getBandeira() throws IOException {
		if (this.pais.getBandeira() != null) {
			return ImageIO.read(new ByteArrayInputStream(this.pais.getBandeira()));
		}
		return null;
	}

}

src/main/java/maxempresarial/controlador/cadastro/UsuarioBean.java
package maxempresarial.controlador.cadastro;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.context.FacesContext;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.hibernate.validator.constraints.NotBlank;
import org.primefaces.event.SelectEvent;

import maxempresarial.modelo.Departamento;
import maxempresarial.modelo.Filial;
import maxempresarial.modelo.Perfil;
import maxempresarial.modelo.Usuario;
import maxempresarial.repositorio.dao.ExcecaoDAO;
import maxempresarial.repositorio.filtro.DepartamentoFiltro;
import maxempresarial.repositorio.filtro.PerfilFiltro;
import maxempresarial.repositorio.pesquisa.DepartamentoPesquisa;
import maxempresarial.repositorio.pesquisa.PerfilPesquisa;
import maxempresarial.servico.ExcecaoRN;
import maxempresarial.servico.UsuarioServico;
import maxempresarial.util.jsf.FacesUtil;

@Named
@ViewScoped
public class UsuarioBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private UsuarioServico usuarioServico;
	@Inject
	private DepartamentoPesquisa departamentoPesquisa;
	@Inject
	private PerfilPesquisa perfilPesquisa;

	private String senha;
	private Usuario usuario;
	private List<Departamento> departamentos = new ArrayList<>();
	private List<Perfil> perfis = new ArrayList<>();

	public UsuarioBean() {
		this.limpar();
	}

	@PostConstruct
	public void inicializar() {
		if (this.usuario == null) {
			this.limpar();
		}
		this.departamentos = this.departamentoPesquisa.filtrados(new DepartamentoFiltro());
		this.perfis = this.perfilPesquisa.filtrados(new PerfilFiltro());
	}

	private void limpar() {
		this.usuario = new Usuario();
	}

	public void salvar() {
		try {
			if (this.senha != null && this.senha.trim().length() > 0) {
				this.usuario.setSenha(this.getSenha());
			}
			this.usuario = this.usuarioServico.salvar(this.usuario);
			this.limpar();

			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("salvo_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("salvo_corretamente_detalhes"));
		} catch (ExcecaoRN ern) {
			FacesUtil.mensagemAviso(FacesUtil.getMensagemInternacionalizacao("atencao_mensagem"), FacesUtil.getMensagemInternacionalizacao(ern.getMessage()));
		} catch (ExcecaoDAO edao) {
			FacesUtil.mensagemErro(FacesUtil.getMensagemInternacionalizacao("salvo_falha_mensagem"),
					FacesUtil.getMensagemInternacionalizacao(edao.getMessage()));
		}
	}

	public void adicionarPerfil() {

	}

	public String getSenha() {
		return senha;
	}

	public void setSenha(String senha) {
		this.senha = senha;
	}

	public void filialSelecionada(SelectEvent event) {
		this.usuario.setFilial((Filial) event.getObject());
	}

	public Usuario getUsuario() {
		return usuario;
	}

	public void setUsuario(Usuario usuario) {
		this.usuario = usuario;
	}

	public List<Departamento> getDepartamentos() {
		return departamentos;
	}

	public List<Perfil> getPerfis() {
		return perfis;
	}

	public boolean isEditando() {
		return this.usuario.getPk() != null;
	}

	public boolean isFaseRenderizacao() {
		if (FacesContext.getCurrentInstance().getCurrentPhaseId().getName().equals("RENDER_RESPONSE")) {
			return true;
		} else {
			return false;
		}

	}

	@NotBlank(message = "Filial não pode esta vazia.")
	public String getNomeFilial() {
		return this.usuario.getFilial() == null ? null : this.usuario.getFilial().getNomeFantasia();
	}

	// metodo para burlar erro do JSF
	public void setNomeFilial(String nome) {
	}

}

src/main/java/maxempresarial/controlador/pesquisa/PesquisaUsuarioBean.java
package maxempresarial.controlador.pesquisa;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.FillPatternType;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.IndexedColors;
import org.primefaces.model.LazyDataModel;
import org.primefaces.model.SortOrder;

import maxempresarial.modelo.Usuario;
import maxempresarial.repositorio.dao.ExcecaoDAO;
import maxempresarial.repositorio.filtro.UsuarioFiltro;
import maxempresarial.repositorio.pesquisa.UsuarioPesquisa;
import maxempresarial.servico.ExcecaoRN;
import maxempresarial.servico.UsuarioServico;
import maxempresarial.util.jsf.FacesUtil;

@Named
@ViewScoped
public class PesquisaUsuarioBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private UsuarioServico usuarioServico;

	@Inject
	private UsuarioPesquisa usuarioPesquisa;

	private UsuarioFiltro filtro;
	private LazyDataModel<Usuario> lazyUsuarios;
	private Usuario usuarioSelecionado;

	public PesquisaUsuarioBean() {
		this.filtro = new UsuarioFiltro();

		this.lazyUsuarios = new LazyDataModel<Usuario>() {

			private static final long serialVersionUID = 1L;

			@Override
			public List<Usuario> load(int primeiroRegistro, int quantidadeRegistros, String propriedadeOrdenacao, SortOrder ascendente,
					Map<String, Object> filters) {

				filtro.setPrimeiroRegistro(primeiroRegistro);
				filtro.setQuantidadeDeRegistros(quantidadeRegistros);
				filtro.setPropriedadeParaOrdenacao(propriedadeOrdenacao);
				filtro.setAscendente(SortOrder.ASCENDING.equals(ascendente));

				this.setRowCount(usuarioPesquisa.quantidadeUsuariosFiltrados(filtro));

				return usuarioPesquisa.filtrados(filtro);
			}
		};
	}

	public void posProcessarXls(Object documento) {
		HSSFWorkbook planilha = (HSSFWorkbook) documento;
		HSSFSheet folha = planilha.getSheetAt(0);
		HSSFRow cabecalho = folha.getRow(0);
		HSSFCellStyle estiloDaCelula = planilha.createCellStyle();
		Font fonteDoCabecalho = planilha.createFont();

		fonteDoCabecalho.setColor(IndexedColors.WHITE.getIndex());
		fonteDoCabecalho.setBold(true);
		fonteDoCabecalho.setFontHeightInPoints((short) 13);

		estiloDaCelula.setFont(fonteDoCabecalho);
		estiloDaCelula.setFillForegroundColor(IndexedColors.BLACK.getIndex());
		estiloDaCelula.setFillPattern(FillPatternType.SOLID_FOREGROUND);

		for (int i = 0; i < cabecalho.getPhysicalNumberOfCells(); i++) {
			cabecalho.getCell(i).setCellStyle(estiloDaCelula);
		}
	}

	public void excluir() {
		try {
			this.usuarioServico.excluir(this.usuarioSelecionado);

			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("exclusao_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("exclusao_corretamente_detalhes"));
		} catch (ExcecaoRN ern) {
			FacesUtil.mensagemAviso(FacesUtil.getMensagemInternacionalizacao("atencao_mensagem"), FacesUtil.getMensagemInternacionalizacao(ern.getMessage()));
		} catch (ExcecaoDAO edao) {
			FacesUtil.mensagemErro(FacesUtil.getMensagemInternacionalizacao("exclusao_falha_mensagem"), edao.getMessage());
		}
	}

	public Usuario getUsuarioSelecionado() {
		return usuarioSelecionado;
	}

	public void setUsuarioSelecionado(Usuario usuarioSelecionado) {
		this.usuarioSelecionado = usuarioSelecionado;
	}

	public UsuarioFiltro getFiltro() {
		return filtro;
	}

	public LazyDataModel<Usuario> getLazyUsuarios() {
		return lazyUsuarios;
	}

}

src/main/webapp/usuarios/auditoriaAuditoria.xhtml
<ui:composition xmlns="http://www.w3.org/1999/xhtml" xmlns:h="http://xmlns.jcp.org/jsf/html" xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets" xmlns:p="http://primefaces.org/ui" xmlns:o="http://omnifaces.org/ui">

	<h:form id="frmAuditoria">
		<p:panelGrid id="painelAuditoria" columns="3" columnClasses="ui-grid-col-2,ui-grid-col-2,ui-grid-col-2" layout="grid" styleClass="ui-panelgrid-blank">
			<p:outputLabel value="#{msg.auditoria_incluiu_por}" styleClass="estilo-campo" />
			<p:inputText value="#{usuarioBean.usuario.auditoria.usuarioIncluiu}" disabled="true" styleClass="estilo-campo" />
			<p:calendar value="#{usuarioBean.usuario.auditoria.dataInclusao}" pattern="dd/MM/yyyy HH:mm:ss" disabled="true" styleClass="estilo-campo" />

			<p:outputLabel value="#{msg.auditoria_alterado_por}" styleClass="estilo-campo" />
			<p:inputText value="#{usuarioBean.usuario.auditoria.usuarioAlterou}" disabled="true" styleClass="estilo-campo" />
			<p:calendar value="#{usuarioBean.usuario.auditoria.dataAlteracao}" pattern="dd/MM/yyyy HH:mm:ss" disabled="true" styleClass="estilo-campo" />
		</p:panelGrid>
	</h:form>
</ui:composition>

src/main/webapp/usuarios/cadastroUsuario.xhtml
<ui:composition template="/WEB-INF/templates/layoutPadrao.xhtml" xmlns="http://www.w3.org/1999/xhtml" xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:f="http://xmlns.jcp.org/jsf/core" xmlns:ui="http://xmlns.jcp.org/jsf/facelets" xmlns:p="http://primefaces.org/ui" xmlns:o="http://omnifaces.org/ui">

	<ui:define name="titulo">#{usuarioBean.editando ? msg.subtitulo_cadastro_usuario_edicao : msg.subtitulo_cadastro_usuario_novo}</ui:define>

	<ui:define name="conteudo">
		<f:metadata>
			<o:viewParam name="usuario" value="#{usuarioBean.usuario}" />
			<f:viewAction action="#{usuarioBean.inicializar}" />
		</f:metadata>

		<h:form id="frmCadastroUsuario">

			<h2>#{usuarioBean.editando ? msg.subtitulo_cadastro_usuario_edicao : msg.subtitulo_cadastro_usuario_novo}</h2>

			<p:toolbar>
				<f:facet name="left">
					<p:button value="#{msg.botao_novo}" outcome="/usuarios/cadastroUsuario" id="botaoNova" />
					<span class="ui-separator"> <span class="ui-icon ui-icon-grip-dotted-vertical" />
					</span>
					<p:commandButton value="#{msg.botao_salvar}" id="botaoSalvar" action="#{usuarioBean.salvar}" update="@(form)" ajax="false" />
				</f:facet>
				<f:facet name="right">
					<p:button value="#{msg.botao_pesquisa}" outcome="/usuarios/pesquisaUsuarios" />
				</f:facet>
			</p:toolbar>

			<p:panelGrid id="painelCadastroUsuario" columns="3" columnClasses="ui-grid-col-2,ui-grid-col-3,ui-grid-col-1" layout="grid" styleClass="ui-panelgrid-blank">

				<p:outputLabel for="codigo" value="#{msg.cadastro_usuario_codigo}" styleClass="estilo-campo" />
				<p:inputText id="codigo" value="#{usuarioBean.usuario.pk}" disabled="true" styleClass="estilo-campo" />
				<p:spacer />

				<p:outputLabel value="#{msg.cadastro_usuario_filial}" for="filial" styleClass="estilo-campo" />
				<p:inputText id="filial" value="#{usuarioBean.nomeFilial}" styleClass="estilo-campo" readonly="#{usuarioBean.faseRenderizacao}" />
				<p:commandButton icon="fa fa-search" process="@this" update="@none" action="#{selecaoFilialBean.abrirDialogo}" ignoreAutoUpdate="true">
					<p:ajax event="dialogReturn" listener="#{usuarioBean.filialSelecionada}" update="filial" ignoreAutoUpdate="true" />
				</p:commandButton>

				<p:outputLabel for="nome" value="#{msg.cadastro_usuario_nome}" styleClass="estilo-campo" />
				<p:inputText id="nome" value="#{usuarioBean.usuario.nome}" styleClass="estilo-campo" />
				<p:message for="nome" display="icon" />

				<p:outputLabel for="departamento" value="#{msg.cadastro_usuario_departamento}" styleClass="estilo-campo" />
				<p:selectOneMenu id="departamento" value="#{usuarioBean.usuario.departamento}" effect="fade" filter="true" filterMatchMode="startsWith"
					styleClass="estilo-campo">
					<f:selectItem itemLabel="#{msg.cadastro_selectitem_vazio}" />
					<f:selectItems value="#{usuarioBean.departamentos}" var="departamento" itemValue="#{departamento}" itemLabel="#{departamento.nome}" />
				</p:selectOneMenu>
				<p:message for="departamento" display="icon" />

				<p:outputLabel for="cargo" value="#{msg.cadastro_usuario_cargo}" styleClass="estilo-campo" />
				<p:inputText id="cargo" value="#{usuarioBean.usuario.cargo}" styleClass="estilo-campo" />
				<p:message for="cargo" display="icon" />

				<p:outputLabel for="login" value="#{msg.cadastro_usuario_login}" styleClass="estilo-campo" />
				<p:inputText id="login" value="#{usuarioBean.usuario.login}" styleClass="estilo-campo" />
				<p:message for="login" display="icon" />

				<p:outputLabel for="senha" value="#{msg.cadastro_usuario_senha}" styleClass="estilo-campo" />
				<p:password id="senha" value="#{usuarioBean.senha}" match="senhaConfirma" feedback="true" pweakLabel="#{msg.feedback_senha_fraca}"
					goodLabel="#{msg.feedback_senha_boa}" strongLabel="#{msg.feedback_senha_forte}" promptLabel="#{msg.feedback_senha_label}" />
				<p:message for="senha" display="icon" />

				<p:outputLabel for="senhaConfirma" value="#{msg.cadastro_usuario_senha_confirma}" styleClass="estilo-campo" />
				<p:password id="senhaConfirma" value="#{usuarioBean.senha}" />
				<p:message for="senhaConfirma" display="icon" />

				<p:outputLabel for="email" value="#{msg.cadastro_usuario_email}" styleClass="estilo-campo" />
				<p:inputText id="email" value="#{usuarioBean.usuario.email}" styleClass="estilo-campo" />
				<p:message for="email" display="icon" />

				<p:outputLabel for="situacao" value="#{msg.cadastro_usuario_situacao}" styleClass="estilo-campo" />
				<p:selectBooleanButton id="situacao" value="#{usuarioBean.usuario.situacao}" onLabel="#{msg.cadastro_usuario_situacao_ativo}"
					offLabel="#{msg.cadastro_usuario_situacao_inativo}" />
				<p:message for="situacao" display="icon" />

			</p:panelGrid>
		</h:form>

		<p:tabView style="margin-top: 10px; background-color: #ffffff; border: 0px;" id="tabViewOpcoes">
			<p:tab title="#{msg.tabview_cadastro_usuario_tab_perfil}">
				<ui:include src="/usuarios/perfil.xhtml" />
			</p:tab>
			<p:tab title="#{msg.tabview_auditoria}">
				<ui:include src="/usuarios/auditoriaAuditoria.xhtml" />
			</p:tab>
		</p:tabView>
	</ui:define>
</ui:composition>